<template>
  <v-container fluid class="pt-0">
    <v-row no-gutters id="search-field">
      <v-col>
        <SearchFieldDark/>
      </v-col>
    </v-row>
    <v-row id="places">
      <v-col v-if="searchStatus === 'loading' || categoriesLoadStatus === 'loading'">
        <div
          v-for="n in 2"
          :key="n"
          class="mt-4 mb-2"
        >
          <v-skeleton-loader
            class="mb-5"
            transition="scale-transition"
            type="heading"
            width="300"
          ></v-skeleton-loader>
          <v-skeleton-loader
            v-for="l in 3"
            :key="l"
            class="mb-2"
            transition="scale-transition"
            type="card-heading"
          ></v-skeleton-loader>
        </div>
      </v-col>
      <v-col v-if="searchStatus === 'success' && categoriesLoadStatus === 'success'">
        <Places title="Рядом с вами" :places="projects.nearest"/>
        <Places title="В вашем городе/районе" :places="projects.others"/>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
  import SearchFieldDark from '../components/SearchFieldDark';
  import Places from '../components/Places';
  import {mapState, mapActions, mapMutations} from 'vuex';

  export default {
    name: 'Search',
    components: {Places, SearchFieldDark},
    computed: {
      ...mapState('search', [
        'projects',
        'searchStatus',
        'ymapsLoaded',
      ]),
      ...mapState('categories', [
        'categoriesLoadStatus',
      ]),
      query: function() {
        return this.$route.query.address;
      },
    },
    methods: {
      ...mapActions('search', [
        'getProjects',
        'setSearchStatus',
      ]),
      ...mapMutations('search', [
        'setProjects',
      ]),
      search: async function(query) {
        this.setSearchStatus('loading');
        this.setProjects({});

        // eslint-disable-next-line
        const res = await ymaps.geocode(query, {
          results: 1,
        });

        const firstGeoObject = res.geoObjects.get(0);
        if (!firstGeoObject) {
          this.setSearchStatus('success');
          return;
        }
        const coords = firstGeoObject.geometry.getCoordinates();
        const city = firstGeoObject.getLocalities()[0];
        if (!city.length) {
          this.setSearchStatus('success');
          return;
        }

        const address = {
          att: coords[0],
          long: coords[1],
          city,
        };

        await this.getProjects(address);

        this.setSearchStatus('success');
      },
    },
    async created() {
      this.setSearchStatus('loading');
      if (this.ymapsLoaded) {
        const query = this.$route.query.address;

        this.search(query);
      }
    },
    watch: {
      query(newValue) {
        this.search(newValue);
      },
      ymapsLoaded() {
        const query = this.$route.query.address;

        this.search(query);
      }
    },
  };
</script>

<style scoped>

</style>

